/*
 * NoteSpectrum.h
 *
 *  Created on: 27 déc. 2023
 *      Author: fanch
 */

#ifndef SRC_PLUGINS_NOTESPECTRUM_H_
#define SRC_PLUGINS_NOTESPECTRUM_H_
#include <string>
#include <cstdint>
#include <cstring>
#include <cmath>


struct Note {
	constexpr static const char NOTE_LETTERS[12][3]  = {"A", "A#", "B", "C", "C#", "D", "D#",  "E", "F", "F#", "G", "G#"};
	const uint8_t NOTE_COUNT = 12;
	std::string fullname;
	uint8_t note;
	int8_t octave;
	const char* letter;
	float frequency;
	uint8_t midi;

	Note(int m){
		midi = m;
		frequency = 440.0 * pow(2, (midi-69)/12);
		octave = midi /12-1;
		note = (midi+3) % 12;
		letter = NOTE_LETTERS[note];
	}
};



extern const Note Notes[128];



class NoteSpectrum {
public:
	NoteSpectrum();
	virtual ~NoteSpectrum();
};

#endif /* SRC_PLUGINS_NOTESPECTRUM_H_ */
